org.apache.poi.hslf.model

## Class ActiveXShape

- java.lang.Object
- - org.apache.poi.hslf.usermodel.HSLFShape
  - - org.apache.poi.hslf.usermodel.HSLFSimpleShape
    - - org.apache.poi.hslf.usermodel.HSLFPictureShape
      - - org.apache.poi.hslf.model.ActiveXShape

- All Implemented Interfaces:
    IAdjustableShape, PictureShape<HSLFShape,HSLFTextParagraph>, PlaceableShape<HSLFShape,HSLFTextParagraph>, Shape<HSLFShape,HSLFTextParagraph>, SimpleShape<HSLFShape,HSLFTextParagraph>

      public final class ActiveXShape
      extends HSLFPictureShape

  Represents an ActiveX control in a PowerPoint document.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_ACTIVEX_THUMBNAIL`

    - ### Fields inherited from class org.apache.poi.hslf.usermodel.HSLFSimpleShape

      `_hyperlink, ADJUST_VALUES, DEFAULT_LINE_WIDTH`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ActiveXShape(EscherContainerRecord escherRecord, ShapeContainer<HSLFShape,HSLFTextParagraph> parent)` Create a `Picture` object
    `` | `ActiveXShape(int movieIdx, HSLFPictureData pictureData)` Create a new `Picture`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `afterInsert(HSLFSheet sheet)` By default set the orininal image size
    `protected EscherContainerRecord` | `createSpContainer(int idx, boolean isChild)` Create a new Placeholder and initialize internal structures
    `int` | `getControlIndex()`
    `ExControl` | `getExControl()` Document-level container that specifies information about an ActiveX control
    `void` | `setActiveXIndex(int idx)` Assign a control to this shape
    `void` | `setProperty(java.lang.String key, java.lang.String value)` Set a property of this ActiveX control

    - ### Methods inherited from class org.apache.poi.hslf.usermodel.HSLFPictureShape

      `getClipping, getEscherBSERecord, getPictureData, getPictureIndex, getPictureName, getShapeType, setPictureName`

    - ### Methods inherited from class org.apache.poi.hslf.usermodel.HSLFSimpleShape

      `createHyperlink, createSpContainer, getAdjustValue, getFillColor, getGeometry, getHyperlink, getLineBackgroundColor, getLineCap, getLineColor, getLineCompound, getLineDash, getLineDecoration, getLineHeadDecoration, getLineHeadLength, getLineHeadWidth, getLineTailDecoration, getLineTailLength, getLineTailWidth, getLineWidth, getPlaceholder, getPlaceholderDetails, getShadow, getShadowAngle, getShadowColor, getShadowDistance, getStrokeStyle, isPlaceholder, setFillColor, setHyperlink, setLineBackgroundColor, setLineCap, setLineColor, setLineCompound, setLineDash, setLineHeadDecoration, setLineHeadLength, setLineHeadWidth, setLineTailDecoration, setLineTailLength, setLineTailWidth, setLineWidth, setPlaceholder, setStrokeStyle`

    - ### Methods inherited from class org.apache.poi.hslf.usermodel.HSLFShape

      `draw, getAnchor, getClientData, getClientDataRecord, getClientRecords, getEscherChild, getEscherChild, getEscherChild, getEscherChild, getEscherOptRecord, getEscherProperty, getEscherProperty, getEscherProperty, getEscherProperty, getEscherProperty, getEscherProperty, getFill, getFillStyle, getFlipHorizontal, getFlipVertical, getParent, getRotation, getShapeId, getShapeName, getSheet, getSpContainer, moveTo, setAnchor, setEscherProperty, setEscherProperty, setEscherProperty, setEscherProperty, setEscherProperty, setFlipHorizontal, setFlipVertical, setRotation, setShapeId, setShapeType, setSheet`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.poi.sl.usermodel.PictureShape

      `getAlternativePictureData`

    - ### Methods inherited from interface org.apache.poi.sl.usermodel.SimpleShape

      `createHyperlink, getFillColor, getFillStyle, getGeometry, getHyperlink, getLineDecoration, getPlaceholder, getPlaceholderDetails, getShadow, getStrokeStyle, isPlaceholder, setFillColor, setPlaceholder, setShapeType, setStrokeStyle`

    - ### Methods inherited from interface org.apache.poi.sl.usermodel.Shape

      `draw, getAnchor, getParent, getShapeId, getShapeName, getSheet`

    - ### Methods inherited from interface org.apache.poi.sl.draw.geom.IAdjustableShape

      `getAdjustValue`

    - ### Methods inherited from interface org.apache.poi.sl.usermodel.PlaceableShape

      `getAnchor, getFlipHorizontal, getFlipVertical, getParent, getRotation, getSheet, setAnchor, setFlipHorizontal, setFlipVertical, setRotation`

- - ### Field Detail

    - #### DEFAULT_ACTIVEX_THUMBNAIL

          public static final int DEFAULT_ACTIVEX_THUMBNAIL

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ActiveXShape

          public ActiveXShape(int movieIdx,
                              HSLFPictureData pictureData)

      Create a new `Picture`
      Parameters:
        `pictureData` - the picture data

    - #### ActiveXShape

          protected ActiveXShape(EscherContainerRecord escherRecord,
                                 ShapeContainer<HSLFShape,HSLFTextParagraph> parent)

      Create a `Picture` object
      Parameters:
        `escherRecord` - the `EscherSpContainer` record which holds information about this picture in the `Slide`
        `parent` - the parent shape of this picture

  - ### Method Detail

    - #### createSpContainer

          protected EscherContainerRecord createSpContainer(int idx,
                                                            boolean isChild)

      Create a new Placeholder and initialize internal structures
      Overrides:
        `createSpContainer` in class `HSLFPictureShape`
      Parameters:
        `idx` - the index of the picture which refers to `EscherBSE` container.
      Returns:
        the created `EscherContainerRecord` which holds shape data

    - #### setActiveXIndex

          public void setActiveXIndex(int idx)

      Assign a control to this shape
      Parameters:
        `idx` - the index of the movie
      See Also:
        `HSLFSlideShow.addMovie(String, int)`

    - #### getControlIndex

          public int getControlIndex()

    - #### setProperty

          public void setProperty(java.lang.String key,
                                  java.lang.String value)

      Set a property of this ActiveX control
      Parameters:
        `key` -
        `value` -

    - #### getExControl

          public ExControl getExControl()

      Document-level container that specifies information about an ActiveX control
      Returns:
        container that specifies information about an ActiveX control

    - #### afterInsert

          protected void afterInsert(HSLFSheet sheet)

      Description copied from class: `HSLFPictureShape`
      By default set the orininal image size
      Overrides:
        `afterInsert` in class `HSLFPictureShape`
      Parameters:
        `sheet` - - owning shape

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.